<?php

namespace Teknisa\EST\Modules\Relatorios\Services;

use Doctrine\ORM\EntityManager;

class Est46000EmissaoAjusteInventarioService {

    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function procMovimentaEstoque($cdfilial,$cdalmoxarife, $cdlocalestoq, $nrloteestq, $tamnivel, $dtinicial,$dtfinal,$prodini,$prodfin,$idlancto,$idcusto,$sequencial,$movconsolid,$custoalmox,$delmovient){

      if(!$this->connection)
        $this->connection = $this->entityManager->getConnection();
        $stmt = $this->connection->prepare('CALL MOVIMENTACAO_ESTOQUE(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)');
        $stmt->bindParam(1, $cdfilial,  \PDO::PARAM_STR);
        $stmt->bindParam(2, $cdalmoxarife,  \PDO::PARAM_STR);
        $stmt->bindParam(3, $cdlocalestoq,  \PDO::PARAM_STR);
        $stmt->bindParam(4, $nrloteestq,  \PDO::PARAM_STR);
        $stmt->bindParam(5, $tamnivel,  \PDO::PARAM_STR);
        $stmt->bindParam(6, $dtinicial,  \PDO::PARAM_STR);
        $stmt->bindParam(7, $dtfinal,  \PDO::PARAM_STR);
        $stmt->bindParam(8, $prodini,  \PDO::PARAM_STR);
        $stmt->bindParam(9, $prodfin,  \PDO::PARAM_STR);
        $stmt->bindParam(10,$idlancto,  \PDO::PARAM_STR);
        $stmt->bindParam(11,$idcusto,  \PDO::PARAM_STR);
        $stmt->bindParam(12,$sequencial,  \PDO::PARAM_STR);
        $stmt->bindParam(13,$movconsolid,  \PDO::PARAM_STR);
        $stmt->bindParam(14,$custoalmox,  \PDO::PARAM_STR);
        $stmt->bindParam(15,$delmovient,  \PDO::PARAM_STR);
        $stmt->execute();

    }

    public function selectAjusteAnalitico($nvTotalizacao,$dtini,$dtfin,$prodini,$prodfin,$sequencial,$ordenar,$idtipocust) {
        $sql = "SELECT NULL AS ID,B.*, NVL(DECODE(:P_IDTIPOCUST,1,VRTOTAL,VRTOTBRUT)*DECODE(QTESTATUA,0,-1,1),0) AS VRTOTAPRESENT FROM (
                SELECT TO_CHAR(A.DTLANCMOVI,'DD/MM/YYYY') AS DTLANCMOVI,TO_CHAR(A.DTLANCMOVI,'YYYYMMDD') AS DTORDENA, A.CDPRODUTO, R.CDPRODMOVIEST AS CDARVPROD,
                       R.NMPRODMOVIEST AS NMPRODUTO, R.SGUNIDMOVI as SGUNIDADE, A.QTLANCTOEST AS QTESTATUA, R.QTTOTALANT AS QTESTANTE, NVL(R.VRCUSTMEDI,0) AS VRUNITARIO,
                       (A.QTLANCTOEST - R.QTTOTALANT) AS QTDIFINVE, SUBSTR(R.CDPRODMOVIEST,0, :P_TAMNVTOT) AS NIVELPROD, SUBSTR(:P_DATAINICIAL,1,15) AS DATAINI,
                       SUBSTR(:P_DATAFINAL,1,15) AS DATAFIN, SUBSTR(:P_PRODINICIAL,1,15) AS CDPRODINICIAL, SUBSTR(:P_PRODFINAL,1,15) AS CDPRODFINAL,
                       NVL(DECODE(A.QTLANCTOEST, 0, (ROUND(R.QTTOTALANT,3)* ROUND(R.VRCUSTMEDI,5)) ,(ROUND((A.QTLANCTOEST -R.QTTOTALANT),3)* ROUND(R.VRCUSTMEDI,5))),0)AS VRTOTAL,
                       NVL(DECODE(A.QTLANCTOEST, 0, (ROUND(R.QTTOTALANT,3)* ROUND(R.VRCUSTMEDI,5)) ,(ROUND((A.QTLANCTOEST -R.QTTOTALANT),3)* ROUND(R.VRCUSTMEDI,5))),0)AS VRTOTBRUT,
                       A.NRLOTEESTQ, A.NRSUBLOTE, A.CDOPERADOR, L.DTVALILOTE
                  FROM ITLANCTOEST A, RELAT_MOVIEST R, LOTE L
                 WHERE (A.CDFILIMOVI   = R.CDFILIMOVIEST)
                   AND (A.NRLANCESTQ   = R.NRLANCMOVIEST)
                   AND (A.NRSEQUITEM   = R.NRSEQUMOVIEST)
                   AND (A.CDALMOXARIFE = R.CDALMOXARIRM)
                   AND (A.CDLOCALESTOQ = R.CDLOCALESTRM)
                   AND (A.IDTIPOMOVI   = R.IDTIPOMOVIEST)
                   AND (A.IDTIPOMOVI   = '1')

                   AND (A.CDFILIMOVI   = L.CDFILIAL)
                   AND (A.NRLOTEESTQ   = L.NRLOTEESTQ)
                   AND (A.NRSUBLOTE    = L.NRSUBLOTE )
                   AND (A.CDPRODMOVI   = L.CDPRODUTO)
                   AND (R.NRRELATMOVI  = :P_NRRELATMOVI)

                 ORDER BY DTORDENA, DECODE(:P_ORDENAR, '0', ABS(A.QTLANCTOEST - R.QTTOTALANT), 0) DESC , R.CDPRODMOVIEST) B";
        $params = array("P_TAMNVTOT"=>$nvTotalizacao,
                        "P_DATAINICIAL"=>$dtini,
                        "P_DATAFINAL"=>$dtfin,
                        "P_PRODINICIAL"=>$prodini,
                        "P_PRODFINAL"=>$prodfin,
                        "P_NRRELATMOVI"=>$sequencial,
                        "P_ORDENAR"=>$ordenar,
                        "P_IDTIPOCUST"=>$idtipocust);
        if(!$this->connection)
          $this->connection = $this->entityManager->getConnection();
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }

    public function selectParentAjusteAnalitico($sequencial,$idtipocust) {
        $sql = "SELECT B.*, NVL(DECODE(:P_IDTIPOCUST,1,VRTOTAL,VRTOTBRUT),0) VRTOTDIA,
                      'Total:' AS DTLANCMOVI,
                      TO_CHAR(TO_DATE(ID),'YYYYMMDD') AS DTORDENA
                 FROM (SELECT TO_CHAR(A.DTLANCMOVI,'DD/MM/YYYY') AS ID,
                              SUM(A.VRTOTAL*DECODE(QTESTATUA,0,-1,1)) VRTOTAL,
                              SUM(A.VRTOTBRUT*DECODE(QTESTATUA,0,-1,1)) VRTOTBRUT
                         FROM (SELECT A.DTLANCMOVI, A.QTLANCTOEST AS QTESTATUA,
                                      DECODE(A.QTLANCTOEST, 0, (ROUND(R.QTTOTALANT,3)* ROUND(R.VRCUSTMEDI,5)) ,(ROUND((A.QTLANCTOEST -R.QTTOTALANT),3)* ROUND(R.VRCUSTMEDI,5))) AS VRTOTAL,
                                      DECODE(A.QTLANCTOEST, 0, (ROUND(R.QTTOTALANT,3)* ROUND(R.VRCUSTMEDI,5)) ,(ROUND((A.QTLANCTOEST -R.QTTOTALANT),3)* ROUND(R.VRCUSTMEDI,5))) AS VRTOTBRUT
                                 FROM ITLANCTOEST A,RELAT_MOVIEST R
                                WHERE (A.CDFILIMOVI   = R.CDFILIMOVIEST)
                                  AND (A.NRLANCESTQ   = R.NRLANCMOVIEST)
                                  AND (A.NRSEQUITEM   = R.NRSEQUMOVIEST)
                                  AND (A.CDALMOXARIFE = R.CDALMOXARIRM)
                                  AND (A.CDLOCALESTOQ = R.CDLOCALESTRM)
                                  AND (A.IDTIPOMOVI   = R.IDTIPOMOVIEST)
                                  AND (A.IDTIPOMOVI   = '1')
                                  AND (R.NRRELATMOVI  = :P_NRRELATMOVI)) A
                        GROUP BY TO_CHAR(A.DTLANCMOVI,'DD/MM/YYYY')
                  )B
                ORDER BY DTORDENA";
        $params = array("P_NRRELATMOVI"=>$sequencial,
                        "P_IDTIPOCUST"=>$idtipocust);
        if(!$this->connection)
          $this->connection = $this->entityManager->getConnection();
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
}