/* Tabela CIAFILI: CIAFILI */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CIAFILI */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CIAFILI,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_CIAFILI
AFTER DELETE OR INSERT OR UPDATE
ON CIAFILI FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.CDTPINDICE IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTpIndice=' || :OLD.CDTPINDICE;
      END IF;
      
      IF :OLD.IDPERVALOR IS NOT NULL THEN
         V_DESC := V_DESC || ' IdPerValor=' || :OLD.IDPERVALOR;
      END IF;
      
      IF :OLD.CDINDICE IS NOT NULL THEN
         V_DESC := V_DESC || ' CdIndice=' || :OLD.CDINDICE;
      END IF;
      
      IF :OLD.CDCICLO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCiclo=' || :OLD.CDCICLO;
      END IF;
      
      IF :OLD.DTULTFECH IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltFech=' || :OLD.DTULTFECH;
      END IF;
      
      IF :OLD.DSBANDEIRA IS NOT NULL THEN
         V_DESC := V_DESC || ' DsBandeira=' || :OLD.DSBANDEIRA;
      END IF;
      
      IF :OLD.QTDIASFATURA IS NOT NULL THEN
         V_DESC := V_DESC || ' QtDiasFatura=' || :OLD.QTDIASFATURA;
      END IF;
      
      IF :OLD.VRALTXPORT IS NOT NULL THEN
         V_DESC := V_DESC || ' VrAltXPort=' || :OLD.VRALTXPORT;
      END IF;
     
      IF :OLD.IDTRIBTXPORT IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTribTxPort=' || :OLD.IDTRIBTXPORT;
      END IF;

      IF :OLD.CDNBMEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdNbmExp' || :OLD.CDNBMEXP;
      END IF;
      
      IF :OLD.CDNALIEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdNaliExp' || :OLD.CDNALIEXP;
      END IF;
      
      IF :OLD.CDMOEEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdMoeExp' || :OLD.CDMOEEXP;
      END IF;
      
      IF :OLD.CDENQEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdEnqExp' || :OLD.CDENQEXP;
      END IF;
      
      IF :OLD.CDEMBEXP IS NOT NULL THEN
         V_DESC := V_DESC || 'CdEmbExp=' || :OLD.CDEMBEXP;
      END IF;
      
      IF :OLD.CDREGEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdRegExp=' || :OLD.CDREGEXP;
      END IF;
      
      IF :OLD.CDANEXEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdAnexExp=' || :OLD.CDANEXEXP;
      END IF;
      
      IF :OLD.DSEMPEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' DsEmpExp=' || :OLD.DSEMPEXP;
      END IF;
      
      IF :OLD.DSROTACICLO IS NOT NULL THEN
         V_DESC := V_DESC || ' DsRotaCiclo=' || :OLD.DSROTACICLO;
      END IF;
      
      IF :OLD.NRHRLIMPREV IS NOT NULL THEN
           V_DESC := V_DESC || ' NrHrLimPrev=' || :OLD.NRHRLIMPREV;
      END IF;
      
      IF :OLD.VRPERSBYUT IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPersByut=' || :OLD.VRPERSBYUT;
      END IF;
      
      IF :OLD.VRPERSBYNUT IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPersBynut=' || :OLD.VRPERSBYNUT;
      END IF;
      
      IF :OLD.IDDESCDESV IS NOT NULL THEN
         V_DESC := V_DESC || ' IdDescDesv=' || :OLD.IDDESCDESV;
      END IF;
      
      IF :OLD.IDDESCCOND IS NOT NULL THEN
         V_DESC := V_DESC || ' IdDescCond=' || :OLD.IDDESCCOND;
      END IF;
     
      IF :OLD.IDDESCFIXO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdDescFixo=' || :OLD.IDDESCFIXO;
      END IF;

      IF :OLD.VRPEDESCFIXO IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPeDescFixo' || :OLD.VRPEDESCFIXO;
      END IF;
      
      IF :OLD.DSDIRFOTOCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DsDirFotoCia' || :OLD.DSDIRFOTOCIA;
      END IF;
      
      IF :OLD.CDTIPEMNF IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTipEmNf' || :OLD.CDTIPEMNF;
      END IF;
      
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdEmpresa' || :OLD.CDEMPRESA;
      END IF;
      
      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || 'CdInscEsta=' || :OLD.CDINSCESTA;
      END IF;
      
      IF :OLD.CDINSCMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' CdInscMuni=' || :OLD.CDINSCMUNI;
      END IF;
      
      IF :OLD.CDSERIE IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSerie=' || :OLD.CDSERIE;
      END IF;
      
      IF :OLD.DTULTATUCFIL IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtucFil=' || :OLD.DTULTATUCFIL;
      END IF;
      
      IF :OLD.IDBREAKCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' IdBreakCia=' || :OLD.IDBREAKCIA;
      END IF;
      
      IF :OLD.IDTIPOCUSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTipoCusto=' || :OLD.IDTIPOCUSTO;
      END IF;

      IF :OLD.VRCUSTOPROD IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoProd=' || :OLD.VRCUSTOPROD;
      END IF;
      
      IF :OLD.VRCUSRMPDEL IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCusRmpDel=' || :OLD.VRCUSRMPDEL;
      END IF;
      
      IF :OLD.VRCUSTOEQUI IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoEqui=' || :OLD.VRCUSTOEQUI;
      END IF;
      
      IF :OLD.VRCUSTOWRF IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoWrf=' || :OLD.VRCUSTOWRF;
      END IF;
      
      IF :OLD.VRCUSTOMANI IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoMani=' || :OLD.VRCUSTOMANI;
      END IF;      
      
      IF :OLD.VRCUSTONMAN IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoNMan=' || :OLD.VRCUSTONMAN;
      END IF;     
      
      IF :OLD.VRCUSTOESPE IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoEspe=' || :OLD.VRCUSTOESPE;
      END IF;
      
      IF :OLD.IDUTLOCAFATU IS NOT NULL THEN
         V_DESC := V_DESC || ' IdUtiLocaFatu=' || :OLD.IDUTLOCAFATU;
      END IF;
      
      IF :OLD.CDGROPERTABPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdGrOperTabPCia=' || :OLD.CDGROPERTABPCIA;
      END IF;     
      
      IF :OLD.VRPERCONVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPerConVoo=' || :OLD.VRPERCONVOO;
      END IF;
      
      IF :OLD.NRORG IS NOT NULL THEN
         V_DESC := V_DESC || ' NrOrg=' || :OLD.NRORG;
      END IF;

      IF :OLD.DTINCLUSAO IS NOT NULL THEN
         V_DESC := V_DESC || ' DtInclusao=' || :OLD.DTINCLUSAO;
      END IF;     
      
      IF :OLD.DTULTATU IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtu=' || :OLD.DTULTATU;
      END IF;
      
      IF :OLD.NRORGINCLUSAO IS NOT NULL THEN
         V_DESC := V_DESC || ' NrOrgInclusao=' || :OLD.NRORGINCLUSAO;
      END IF;
      
      IF :OLD.CDOPERINCLUSAO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOperInclusao=' || :OLD.CDOPERINCLUSAO;
      END IF;     
      
      IF :OLD.NRORGULTATU IS NOT NULL THEN
         V_DESC := V_DESC || ' NrOrgUltAtu=' || :OLD.NRORGULTATU;
      END IF;
      
      IF :OLD.CDOPERULTATU IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOperUltAtu=' || :OLD.CDOPERULTATU;
      END IF;     
      
      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA;
   ELSE 
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL    ) OR
            (:OLD.CDCIA        <> :NEW.CDCIA       ) OR
            (NVL(:OLD.CDTPINDICE, ' ')   <> NVL(:NEW.CDTPINDICE, ' '))OR
            (NVL(:OLD.IDPERVALOR, ' ')   <> NVL(:NEW.IDPERVALOR, ' '))OR
            (NVL(:OLD.CDINDICE, ' ')     <> NVL(:NEW.CDINDICE, ' '))  OR
            (NVL(:OLD.CDCICLO, ' ')      <> NVL(:NEW.CDCICLO, ' '))   OR
            (NVL(:OLD.DTULTFECH, SYSDATE) <> NVL(:NEW.DTULTFECH, SYSDATE)) OR
            (NVL(:OLD.DSBANDEIRA, ' ')   <> NVL(:NEW.DSBANDEIRA, ' '))OR
            (NVL(:OLD.QTDIASFATURA,0)   <> NVL(:NEW.QTDIASFATURA,0))OR
            (NVL(:OLD.VRALTXPORT, 0)    <> NVL(:NEW.VRALTXPORT, 0)) OR
            (NVL(:OLD.IDTRIBTXPORT, ' ') <> NVL(:NEW.IDTRIBTXPORT, ' ')) OR
            (NVL(:OLD.CDNBMEXP, ' ')     <> NVL(:NEW.CDNBMEXP, ' '))  OR
            (NVL(:OLD.CDNALIEXP, ' ')    <> NVL(:NEW.CDNALIEXP, ' ')) OR
            (NVL(:OLD.CDMOEEXP, ' ')     <> NVL(:NEW.CDMOEEXP, ' '))  OR
            (NVL(:OLD.CDENQEXP, ' ')     <> NVL(:NEW.CDENQEXP, ' '))  OR
            (NVL(:OLD.CDEMBEXP, ' ')     <> NVL(:NEW.CDEMBEXP, ' '))  OR
            (NVL(:OLD.CDREGEXP, ' ')     <> NVL(:NEW.CDREGEXP, ' '))  OR
            (NVL(:OLD.CDANEXEXP, ' ')    <> NVL(:NEW.CDANEXEXP, ' ')) OR
            (NVL(:OLD.DSEMPEXP, ' ')     <> NVL(:NEW.DSEMPEXP, ' ' )) OR
            (NVL(:OLD.DSROTACICLO, ' ')  <> NVL(:NEW.DSROTACICLO, ' ')) OR
            (NVL(:OLD.NRHRLIMPREV, 0)  <> NVL(:NEW.NRHRLIMPREV, 0)) OR
            (:OLD.VRPERSBYUT    <> :NEW.VRPERSBYUT)   OR
            (:OLD.VRPERSBYNUT   <> :NEW.VRPERSBYNUT)  OR
            (:OLD.IDDESCDESV    <> :NEW.IDDESCDESV)   OR
            (:OLD.IDDESCCOND    <> :NEW.IDDESCCOND)   OR
            (:OLD.IDDESCFIXO    <> :NEW.IDDESCFIXO )  OR
            (:OLD.VRPEDESCFIXO  <> :NEW.VRPEDESCFIXO) OR
            (NVL(:OLD.DSDIRFOTOCIA, ' ') <> NVL(:NEW.DSDIRFOTOCIA, ' ')) OR
            (NVL(:OLD.CDTIPEMNF, ' ')    <> NVL(:NEW.CDTIPEMNF, ' '))    OR
            (NVL(:OLD.CDEMPRESA, ' ')    <> NVL(:NEW.CDEMPRESA, ' '))    OR
            (NVL(:OLD.CDINSCESTA, ' ')   <> NVL(:NEW.CDINSCESTA, ' '))   OR
            (NVL(:OLD.CDINSCMUNI, ' ')   <> NVL(:NEW.CDINSCMUNI, ' '))   OR
            (NVL(:OLD.CDSERIE, ' ')      <> NVL(:NEW.CDSERIE, ' '))      OR
            (NVL(:OLD.DTULTATUCFIL, SYSDATE) <> NVL(:NEW.DTULTATUCFIL, SYSDATE)) OR
            (:OLD.IDBREAKCIA     <> :NEW.IDBREAKCIA    ) OR
            (NVL(:OLD.IDTIPOCUSTO, ' ')     <> NVL(:NEW.IDTIPOCUSTO, ' ')) OR
            (NVL(:OLD.VRCUSTOPROD, 0)      <> NVL(:NEW.VRCUSTOPROD, 0)) OR
            (NVL(:OLD.VRCUSRMPDEL, 0)      <> NVL(:NEW.VRCUSRMPDEL, 0)) OR
            (NVL(:OLD.VRCUSTOEQUI, 0)      <> NVL(:NEW.VRCUSTOEQUI, 0)) OR
            (NVL(:OLD.VRCUSTOWRF, 0)       <> NVL(:NEW.VRCUSTOWRF, 0 )) OR
            (NVL(:OLD.VRCUSTOMANI, 0)      <> NVL(:NEW.VRCUSTOMANI, 0)) OR
            (NVL(:OLD.VRCUSTONMAN, 0)      <> NVL(:NEW.VRCUSTONMAN, 0)) OR
            (NVL(:OLD.VRCUSTOESPE, 0)      <> NVL(:NEW.VRCUSTOESPE, 0)) OR
            (NVL(:OLD.CDGROPERTABPCIA, ' ') <> NVL(:NEW.CDGROPERTABPCIA, ' ')) OR
            (NVL(:OLD.VRPERCONVOO, 0)      <> NVL(:NEW.VRPERCONVOO, 0)) OR
            (:OLD.NRORG   <> :NEW.NRORG  ) OR
            (NVL(:OLD.DTINCLUSAO, SYSDATE) <> NVL(:NEW.DTINCLUSAO, SYSDATE)) OR
            (NVL(:OLD.DTULTATU, SYSDATE)   <> NVL(:NEW.DTULTATU, SYSDATE))   OR
            (NVL(:OLD.NRORGINCLUSAO, 0)    <> NVL(:NEW.NRORGINCLUSAO, 0))    OR
            (NVL(:OLD.CDOPERINCLUSAO, ' ')  <> NVL(:NEW.CDOPERINCLUSAO, ' '))  OR
            (NVL(:OLD.NRORGULTATU, 0)      <> NVL(:NEW.NRORGULTATU, 0))      OR
            (NVL(:OLD.CDOPERULTATU, ' ')    <> NVL(:NEW.CDOPERULTATU, ' '))    THEN
            
                                    
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.CDTPINDICE, ' ') <> NVL(:NEW.CDTPINDICE, ' ') THEN
               V_DESC := V_DESC || ' CdTpIndice=' || :OLD.CDTPINDICE || '|' || :NEW.CDTPINDICE;
            END IF;
            
            IF NVL(:OLD.IDPERVALOR, ' ') <> NVL(:NEW.IDPERVALOR, ' ') THEN
               V_DESC := V_DESC || ' IdPerValor=' || :OLD.IDPERVALOR || '|' || :NEW.IDPERVALOR;
            END IF;
            
            IF NVL(:OLD.CDINDICE, ' ') <> NVL(:NEW.CDINDICE, ' ') THEN
               V_DESC := V_DESC || ' CdIndice=' || :OLD.CDINDICE || '|' || :NEW.CDINDICE;
            END IF;
            
            IF NVL(:OLD.CDCICLO, ' ') <> NVL(:NEW.CDCICLO, ' ') THEN
               V_DESC := V_DESC || ' CdCiclo=' || :OLD.CDCICLO || '|' || :NEW.CDCICLO;
            END IF;
            
            IF NVL(:OLD.DTULTFECH, SYSDATE) <> NVL(:NEW.DTULTFECH, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltFech=' || :OLD.DTULTFECH || '|' || :NEW.DTULTFECH;
            END IF;
            
            IF NVL(:OLD.DSBANDEIRA, ' ') <> NVL(:NEW.DSBANDEIRA, ' ') THEN
               V_DESC := V_DESC || ' DsBandeira=' || :OLD.DSBANDEIRA || '|' || :NEW.DSBANDEIRA;
            END IF;
            
            IF NVL(:OLD.QTDIASFATURA, 0) <> NVL(:NEW.QTDIASFATURA, 0) THEN
               V_DESC := V_DESC || ' QtDiasFatura=' || :OLD.QTDIASFATURA || '|' || :NEW.QTDIASFATURA;
            END IF;
            
            IF NVL(:OLD.VRALTXPORT, 0) <> NVL(:NEW.VRALTXPORT, 0) THEN
               V_DESC := V_DESC || ' VrAltXPort=' || :OLD.VRALTXPORT || '|' || :NEW.VRALTXPORT;
            END IF;
           
            IF NVL(:OLD.IDTRIBTXPORT, ' ') <> NVL(:NEW.IDTRIBTXPORT, ' ') THEN
               V_DESC := V_DESC || ' IdTribTxPort=' || :OLD.IDTRIBTXPORT || '|' || :NEW.IDTRIBTXPORT;
            END IF;
      
            IF NVL(:OLD.CDNBMEXP, ' ') <> NVL(:NEW.CDNBMEXP, ' ') THEN
               V_DESC := V_DESC || ' CdNbmExp' || :OLD.CDNBMEXP || '|' || :NEW.CDNBMEXP;
            END IF;
            
            IF NVL(:OLD.CDNALIEXP, ' ') <> NVL(:NEW.CDNALIEXP, ' ') THEN
               V_DESC := V_DESC || ' CdNaliExp' || :OLD.CDNALIEXP || '|' || :NEW.CDNALIEXP;
            END IF;
            
            IF NVL(:OLD.CDMOEEXP, ' ') <> NVL(:NEW.CDMOEEXP, ' ') THEN
               V_DESC := V_DESC || ' CdMoeExp' || :OLD.CDMOEEXP || '|' || :NEW.CDMOEEXP;
            END IF;
            
            IF NVL(:OLD.CDENQEXP, ' ') <> NVL(:NEW.CDENQEXP, ' ') THEN
               V_DESC := V_DESC || ' CdEnqExp' || :OLD.CDENQEXP || '|' || :NEW.CDENQEXP;
            END IF;
            
            IF NVL(:OLD.CDEMBEXP, ' ') <> NVL(:NEW.CDEMBEXP, ' ') THEN
               V_DESC := V_DESC || 'CdEmbExp=' || :OLD.CDEMBEXP || '|' || :NEW.CDEMBEXP;
            END IF;
            
            IF NVL(:OLD.CDREGEXP, ' ') <> NVL(:NEW.CDREGEXP, ' ') THEN
               V_DESC := V_DESC || ' CdRegExp=' || :OLD.CDREGEXP || '|' || :NEW.CDREGEXP;
            END IF;
            
            IF NVL(:OLD.CDANEXEXP, ' ') <> NVL(:NEW.CDANEXEXP, ' ') THEN
               V_DESC := V_DESC || ' CdAnexExp=' || :OLD.CDANEXEXP || '|' || :NEW.CDANEXEXP;
            END IF;
            
            IF NVL(:OLD.DSEMPEXP, ' ') <> NVL(:NEW.DSEMPEXP, ' ') THEN
               V_DESC := V_DESC || ' DsEmpExp=' || :OLD.DSEMPEXP || '|' || :NEW.DSEMPEXP;
            END IF;
            
            IF NVL(:OLD.DSROTACICLO, ' ') <> NVL(:NEW.DSROTACICLO, ' ') THEN
               V_DESC := V_DESC || ' CdIndice=' || :OLD.CDINDICE || '|' || :NEW.CDINDICE;
            END IF;
            
            IF NVL(:OLD.NRHRLIMPREV, 0) <> NVL(:NEW.NRHRLIMPREV, 0) THEN
               V_DESC := V_DESC || ' NrHrLimPrev=' || :OLD.NRHRLIMPREV || '|' || :NEW.NRHRLIMPREV;
            END IF;
            
            IF NVL(:OLD.VRPERSBYUT, 0) <> NVL(:NEW.VRPERSBYUT, 0) THEN
               V_DESC := V_DESC || ' VrPersByut=' || :OLD.VRPERSBYUT || '|' || :NEW.VRPERSBYUT;
            END IF;
            
            IF NVL(:OLD.VRPERSBYNUT, 0) <> NVL(:NEW.VRPERSBYNUT, 0) THEN
               V_DESC := V_DESC || ' VrPersBynut=' || :OLD.VRPERSBYNUT || '|' || :NEW.VRPERSBYNUT;
            END IF;
            
            IF NVL(:OLD.IDDESCDESV, ' ') <> NVL(:NEW.IDDESCDESV, ' ') THEN
               V_DESC := V_DESC || ' IdDescDesv=' || :OLD.IDDESCDESV || '|' || :NEW.IDDESCDESV;
            END IF;
            
            IF NVL(:OLD.IDDESCCOND, ' ') <> NVL(:NEW.IDDESCCOND, ' ') THEN
               V_DESC := V_DESC || ' IdDescCond=' || :OLD.IDDESCCOND || '|' || :NEW.IDDESCCOND;
            END IF;
           
            IF NVL(:OLD.IDDESCFIXO, ' ') <> NVL(:NEW.IDDESCFIXO, ' ') THEN
               V_DESC := V_DESC || ' IdDescFixo=' || :OLD.IDDESCFIXO || '|' || :NEW.IDDESCFIXO;
            END IF;
      
            IF NVL(:OLD.VRPEDESCFIXO, 0) <> NVL(:NEW.VRPEDESCFIXO, 0) THEN
               V_DESC := V_DESC || ' VrPedDescFixo=' || :OLD.VRPEDESCFIXO || '|' || :NEW.VRPEDESCFIXO;
            END IF;
            
            IF NVL(:OLD.DSDIRFOTOCIA, ' ') <> NVL(:NEW.DSDIRFOTOCIA, ' ') THEN
               V_DESC := V_DESC || ' DsDirFotoCia' || :OLD.DSDIRFOTOCIA || '|' || :NEW.DSDIRFOTOCIA;
            END IF;
            
            IF NVL(:OLD.CDTIPEMNF, ' ') <> NVL(:NEW.CDTIPEMNF, ' ') THEN
               V_DESC := V_DESC || ' CdTipEmNf' || :OLD.CDTIPEMNF || '|' || :NEW.CDTIPEMNF;
            END IF;
            
            IF NVL(:OLD.CDEMPRESA, ' ') <> NVL(:NEW.CDEMPRESA, ' ') THEN
               V_DESC := V_DESC || ' CdEmpresa' || :OLD.CDEMPRESA || '|' || :NEW.CDEMPRESA;
            END IF;
            
            IF NVL(:OLD.CDINSCESTA, ' ') <> NVL(:NEW.CDINSCESTA, ' ') THEN
               V_DESC := V_DESC || 'CdInscEsta=' || :OLD.CDINSCESTA || '|' || :NEW.CDINSCESTA;
            END IF;
            
            IF NVL(:OLD.CDINSCMUNI, ' ') <> NVL(:NEW.CDINSCMUNI, ' ') THEN
               V_DESC := V_DESC || ' CdInscMuni=' || :OLD.CDINSCMUNI || '|' || :NEW.CDINSCMUNI;
            END IF;
            
            IF NVL(:OLD.CDSERIE, ' ') <> NVL(:NEW.CDSERIE, ' ') THEN
               V_DESC := V_DESC || ' CdSerie=' || :OLD.CDSERIE || '|' || :NEW.CDSERIE;
            END IF;
            
            IF NVL(:OLD.DTULTATUCFIL, SYSDATE) <> NVL(:NEW.DTULTATUCFIL, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtucFil=' || :OLD.DTULTATUCFIL || '|' || :NEW.DTULTATUCFIL;
            END IF;
            
            IF NVL(:OLD.IDBREAKCIA, ' ') <> NVL(:NEW.IDBREAKCIA, ' ') THEN
               V_DESC := V_DESC || ' IdBreakCia=' || :OLD.IDBREAKCIA || '|' || :NEW.IDBREAKCIA;
            END IF;
            
            IF NVL(:OLD.IDTIPOCUSTO, ' ') <> NVL(:NEW.IDTIPOCUSTO, ' ') THEN
               V_DESC := V_DESC || ' IdTipoCusto=' || :OLD.IDTIPOCUSTO || '|' || :NEW.IDTIPOCUSTO;
            END IF;
            
            IF NVL(:OLD.VRCUSTOPROD, 0) <> NVL(:NEW.VRCUSTOPROD, 0) THEN
               V_DESC := V_DESC || ' VrCustoProd=' || :OLD.VRCUSTOPROD || '|' || :NEW.VRCUSTOPROD;
            END IF;
            
            IF NVL(:OLD.VRCUSRMPDEL, 0) <> NVL(:NEW.VRCUSRMPDEL, 0) THEN
               V_DESC := V_DESC || ' VrCusRmpDel=' || :OLD.VRCUSRMPDEL || '|' || :NEW.VRCUSRMPDEL;
            END IF;
            
            IF NVL(:OLD.VRCUSTOEQUI, 0) <> NVL(:NEW.VRCUSTOEQUI, 0) THEN
               V_DESC := V_DESC || ' VrCustoEqui=' || :OLD.VRCUSTOEQUI || '|' || :NEW.VRCUSTOEQUI;
            END IF;
            
            IF NVL(:OLD.VRCUSTOWRF, 0) <> NVL(:NEW.VRCUSTOWRF, 0) THEN
               V_DESC := V_DESC || ' VrCustoWrf=' || :OLD.VRCUSTOWRF || '|' || :NEW.VRCUSTOWRF;
            END IF;
            
            IF NVL(:OLD.VRCUSTOMANI, 0) <> NVL(:NEW.VRCUSTOMANI, 0) THEN
               V_DESC := V_DESC || ' VrCustoMani=' || :OLD.VRCUSTOMANI || '|' || :NEW.VRCUSTOMANI;
            END IF;
            
            IF NVL(:OLD.VRCUSTONMAN, 0) <> NVL(:NEW.VRCUSTONMAN, 0) THEN
               V_DESC := V_DESC || ' VrCustoNMan=' || :OLD.VRCUSTONMAN || '|' || :NEW.VRCUSTONMAN;
            END IF;
            
            IF NVL(:OLD.VRCUSTOESPE, 0) <> NVL(:NEW.VRCUSTOESPE, 0) THEN
               V_DESC := V_DESC || ' VrCustoEspe=' || :OLD.VRCUSTOESPE || '|' || :NEW.VRCUSTOESPE;
            END IF;
            
            IF NVL(:OLD.IDUTLOCAFATU, ' ') <> NVL(:NEW.IDUTLOCAFATU, ' ') THEN
               V_DESC := V_DESC || ' IdUtiLocaFatu=' || :OLD.IDUTLOCAFATU || '|' || :NEW.IDUTLOCAFATU;
            END IF;
            
            IF NVL(:OLD.CDGROPERTABPCIA, ' ') <> NVL(:NEW.CDGROPERTABPCIA, ' ') THEN
               V_DESC := V_DESC || ' CdGrOperTabPCia=' || :OLD.CDGROPERTABPCIA || '|' || :NEW.CDGROPERTABPCIA;
            END IF;
            
            IF NVL(:OLD.VRPERCONVOO, 0) <> NVL(:NEW.VRPERCONVOO, 0) THEN
               V_DESC := V_DESC || ' VrPerConVoo=' || :OLD.VRPERCONVOO || '|' || :NEW.VRPERCONVOO;
            END IF;
            
            IF NVL(:OLD.NRORG, 0) <> NVL(:NEW.NRORG, 0) THEN
               V_DESC := V_DESC || ' NrOrg=' || :OLD.NRORG || '|' || :NEW.NRORG;
            END IF;
            
            IF NVL(:OLD.DTINCLUSAO, SYSDATE) <> NVL(:NEW.DTINCLUSAO, SYSDATE) THEN
               V_DESC := V_DESC || ' DtInclusao=' || :OLD.DTINCLUSAO || '|' || :NEW.DTINCLUSAO;
            END IF;
            
            IF NVL(:OLD.DTULTATU, SYSDATE) <> NVL(:NEW.DTULTATU, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtu=' || :OLD.DTULTATU || '|' || :NEW.DTULTATU;
            END IF;
            
            IF NVL(:OLD.NRORGINCLUSAO, 0) <> NVL(:NEW.NRORGINCLUSAO, 0) THEN
               V_DESC := V_DESC || ' NrOrgInclusao=' || :OLD.NRORGINCLUSAO || '|' || :NEW.NRORGINCLUSAO;
            END IF;
            
            IF NVL(:OLD.CDOPERINCLUSAO, ' ') <> NVL(:NEW.CDOPERINCLUSAO, ' ') THEN
               V_DESC := V_DESC || ' CoOperInclusao=' || :OLD.CDOPERINCLUSAO || '|' || :NEW.CDOPERINCLUSAO;
            END IF;
            
            IF NVL(:OLD.NRORGULTATU, 0) <> NVL(:NEW.NRORGULTATU, 0) THEN
               V_DESC := V_DESC || ' NrOrgUltAtu=' || :OLD.NRORGULTATU || '|' || :NEW.NRORGULTATU;
            END IF;
            
            IF NVL(:OLD.CDOPERULTATU, ' ') <> NVL(:NEW.CDOPERULTATU, ' ') THEN
               V_DESC := V_DESC || ' CdOperUltAtu=' || :OLD.CDOPERULTATU || '|' || :NEW.CDOPERULTATU;
            END IF;
           
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA;
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL ,' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
          
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' Cia=' || :NEW.CDCIA;
         END IF;
          
         IF NVL(:OLD.CDTPINDICE, ' ') <> NVL(:NEW.CDTPINDICE, ' ') THEN
            V_DESC := V_DESC || ' CdTpIndice=' || :NEW.CDTPINDICE;
         END IF;
          
         IF NVL(:OLD.IDPERVALOR, ' ') <> NVL(:NEW.IDPERVALOR, ' ') THEN
            V_DESC := V_DESC || ' IdPerValor=' || :NEW.IDPERVALOR;
         END IF;
          
         IF NVL(:OLD.CDINDICE, ' ') <> NVL(:NEW.CDINDICE, ' ') THEN
            V_DESC := V_DESC || ' CdIndice=' || :NEW.CDINDICE;
         END IF;
          
         IF NVL(:OLD.CDCICLO, ' ') <> NVL(:NEW.CDCICLO, ' ') THEN
            V_DESC := V_DESC || ' CdCiclo=' || :NEW.CDCICLO;
         END IF;
          
         IF NVL(:OLD.DTULTFECH, SYSDATE) <> NVL(:NEW.DTULTFECH, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltFech=' || :NEW.DTULTFECH;
         END IF;
          
         IF NVL(:OLD.DSBANDEIRA, ' ') <> NVL(:NEW.DSBANDEIRA ,' ') THEN
            V_DESC := V_DESC || ' DsBandeira=' || :NEW.DSBANDEIRA;
         END IF;
          
         IF NVL(:OLD.QTDIASFATURA, 0) <> NVL(:NEW.QTDIASFATURA, 0) THEN
            V_DESC := V_DESC || ' QtDiasFatura=' || :NEW.QTDIASFATURA;
         END IF;
          
         IF NVL(:OLD.VRALTXPORT, 0) <> NVL(:NEW.VRALTXPORT, 0) THEN
            V_DESC := V_DESC || ' VrAltXPort=' || :NEW.VRALTXPORT;
         END IF;
         
         IF NVL(:OLD.IDTRIBTXPORT, ' ') <> NVL(:NEW.IDTRIBTXPORT, ' ') THEN
            V_DESC := V_DESC || ' IdTribTxPort=' || :NEW.IDTRIBTXPORT;
         END IF;
    
         IF NVL(:OLD.CDNBMEXP, ' ') <> NVL(:NEW.CDNBMEXP,' ') THEN
            V_DESC := V_DESC || ' CdNbmExp=' || :NEW.CDNBMEXP;
         END IF;
          
         IF NVL(:OLD.CDNALIEXP, ' ') <> NVL(:NEW.CDNALIEXP,' ') THEN
            V_DESC := V_DESC || ' CdNaliExp=' || :NEW.CDNALIEXP;
         END IF;
         
         IF NVL(:OLD.CDMOEEXP, ' ') <> NVL(:NEW.CDMOEEXP,' ') THEN
            V_DESC := V_DESC || ' CdMoeExp=' || :NEW.CDMOEEXP;
         END IF;
          
         IF NVL(:OLD.CDENQEXP, ' ') <> NVL(:NEW.CDENQEXP,' ') THEN
            V_DESC := V_DESC || ' CdEnqExp=' || :NEW.CDENQEXP;
         END IF;
         
         IF NVL(:OLD.CDEMBEXP, ' ') <> NVL(:NEW.CDEMBEXP, ' ') THEN
            V_DESC := V_DESC || 'CdEmbExp=' || :NEW.CDEMBEXP;
         END IF;
          
         IF NVL(:OLD.CDREGEXP, ' ') <> NVL(:NEW.CDREGEXP, ' ') THEN
            V_DESC := V_DESC || ' CdRegExp=' || :NEW.CDREGEXP;
         END IF;
          
         IF NVL(:OLD.CDANEXEXP, ' ') <> NVL(:NEW.CDANEXEXP, ' ') THEN
            V_DESC := V_DESC || ' CdAnexExp=' || :NEW.CDANEXEXP;
         END IF;
          
         IF NVL(:OLD.DSEMPEXP, ' ') <> NVL(:NEW.DSEMPEXP, ' ') THEN
            V_DESC := V_DESC || ' DsEmpExp=' || :NEW.DSEMPEXP;
         END IF;
          
         IF NVL(:OLD.DSROTACICLO, ' ') <> NVL(:NEW.DSROTACICLO, ' ') THEN
            V_DESC := V_DESC || ' DsRotaCiclo=' || :NEW.DSROTACICLO;
         END IF;
          
         IF NVL(:OLD.NRHRLIMPREV, 0) <> NVL(:NEW.NRHRLIMPREV, 0) THEN
            V_DESC := V_DESC || ' NrHrLimPrev=' || :NEW.NRHRLIMPREV;
         END IF;
          
         IF NVL(:OLD.VRPERSBYUT, 0) <> NVL(:NEW.VRPERSBYUT, 0) THEN
            V_DESC := V_DESC || ' VrPersByut=' || :NEW.VRPERSBYUT;
         END IF;
          
         IF NVL(:OLD.VRPERSBYNUT, 0) <> NVL(:NEW.VRPERSBYNUT, 0) THEN
            V_DESC := V_DESC || ' VrPersByNut=' || :NEW.VRPERSBYNUT;
         END IF;
          
         IF NVL(:OLD.IDDESCDESV, ' ') <> NVL(:NEW.IDDESCDESV, ' ') THEN
            V_DESC := V_DESC || ' IdDescDesv=' || :NEW.IDDESCDESV;
         END IF;
          
         IF NVL(:OLD.IDDESCCOND, ' ') <> NVL(:NEW.IDDESCCOND, ' ') THEN
            V_DESC := V_DESC || ' IdDescCond=' || :NEW.IDDESCCOND;
         END IF;
         
         IF NVL(:OLD.IDDESCFIXO, ' ') <> NVL(:NEW.IDDESCFIXO, ' ') THEN
            V_DESC := V_DESC || ' IdDescFixo=' || :NEW.IDDESCFIXO;
         END IF;
    
         IF NVL(:OLD.VRPEDESCFIXO, 0) <> NVL(:NEW.VRPEDESCFIXO, 0) THEN
            V_DESC := V_DESC || ' VrPeDescFixo=' || :NEW.VRPEDESCFIXO;
         END IF;
          
         IF NVL(:OLD.DSDIRFOTOCIA, ' ') <> NVL(:NEW.DSDIRFOTOCIA, ' ') THEN
            V_DESC := V_DESC || ' DsDirFotoCia=' || :NEW.DSDIRFOTOCIA;
         END IF;
         
         IF NVL(:OLD.CDTIPEMNF, ' ') <> NVL(:NEW.CDTIPEMNF, ' ') THEN
            V_DESC := V_DESC || ' CdTipEmNf=' || :NEW.CDTIPEMNF;
         END IF;
          
         IF NVL(:OLD.CDEMPRESA, ' ') <> NVL(:NEW.CDEMPRESA, ' ') THEN
            V_DESC := V_DESC || ' CdEmpresa=' || :NEW.CDEMPRESA;
         END IF;
         
         IF NVL(:OLD.CDINSCESTA, ' ') <> NVL(:NEW.CDINSCESTA, ' ') THEN
            V_DESC := V_DESC || ' CdInscEsta=' || :NEW.CDINSCESTA;
         END IF;
          
         IF NVL(:OLD.CDINSCMUNI, ' ') <> NVL(:NEW.CDINSCMUNI, ' ') THEN
            V_DESC := V_DESC || ' CdInscMuni=' || :NEW.CDINSCMUNI;
         END IF;
          
         IF NVL(:OLD.CDSERIE, ' ') <> NVL(:NEW.CDSERIE, ' ') THEN
            V_DESC := V_DESC || ' CdSerie=' || :NEW.CDSERIE;
         END IF;
          
         IF NVL(:OLD.DTULTATUCFIL, SYSDATE) <> NVL(:NEW.DTULTATUCFIL, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtucFil=' || :NEW.DTULTATUCFIL;
         END IF;
          
         IF NVL(:OLD.IDBREAKCIA, ' ') <> NVL(:NEW.IDBREAKCIA, ' ') THEN
            V_DESC := V_DESC || ' IdBreakCia=' || :NEW.IDBREAKCIA;
         END IF;
          
         IF NVL(:OLD.IDTIPOCUSTO, ' ') <> NVL(:NEW.IDTIPOCUSTO, ' ') THEN
            V_DESC := V_DESC || ' IdTipoCusto=' || :NEW.IDTIPOCUSTO;
         END IF;
         
         IF NVL(:OLD.VRCUSTOPROD, 0) <> NVL(:NEW.VRCUSTOPROD, 0) THEN
            V_DESC := V_DESC || ' VrCustoProd=' || :NEW.VRCUSTOPROD;
         END IF;
          
         IF NVL(:OLD.VRCUSRMPDEL, 0) <> NVL(:NEW.VRCUSRMPDEL, 0) THEN
            V_DESC := V_DESC || ' VrCusRmpDel=' || :NEW.VRCUSRMPDEL;
         END IF;
          
         IF NVL(:OLD.VRCUSTOEQUI, 0) <> NVL(:NEW.VRCUSTOEQUI, 0) THEN
            V_DESC := V_DESC || ' VrCustoEqui=' || :NEW.VRCUSTOEQUI;
         END IF;
          
         IF NVL(:OLD.VRCUSTOWRF, 0) <> NVL(:NEW.VRCUSTOWRF, 0) THEN
            V_DESC := V_DESC || ' VrCustoWrf=' || :NEW.VRCUSTOWRF;
         END IF;
          
         IF NVL(:OLD.VRCUSTOMANI, 0) <> NVL(:NEW.VRCUSTOMANI, 0) THEN
            V_DESC := V_DESC || ' VrCustoMani=' || :NEW.VRCUSTOMANI;
         END IF;
         
         IF NVL(:OLD.VRCUSTONMAN, 0) <> NVL(:NEW.VRCUSTONMAN, 0) THEN
            V_DESC := V_DESC || ' VrCustoNMan=' || :NEW.VRCUSTONMAN;
         END IF;
         
         IF NVL(:OLD.VRCUSTOESPE, 0) <> NVL(:NEW.VRCUSTOESPE, 0) THEN
            V_DESC := V_DESC || ' VrCustoEspe=' || :NEW.VRCUSTOESPE;
         END IF;
         
         IF NVL(:OLD.IDUTLOCAFATU, ' ') <> NVL(:NEW.IDUTLOCAFATU, ' ') THEN
            V_DESC := V_DESC || ' IdUtiLocaFatu=' || :NEW.IDUTLOCAFATU;
         END IF;
         
         IF NVL(:OLD.CDGROPERTABPCIA, ' ') <> NVL(:NEW.CDGROPERTABPCIA, ' ') THEN
            V_DESC := V_DESC || ' CdGrOperTabPCia=' || :NEW.CDGROPERTABPCIA;
         END IF;
         
         IF NVL(:OLD.VRPERCONVOO, 0) <> NVL(:NEW.VRPERCONVOO, 0) THEN
            V_DESC := V_DESC || ' VerPerConVoo=' || :NEW.VRPERCONVOO;
         END IF;
         
         IF NVL(:OLD.NRORG, 0) <> NVL(:NEW.NRORG, 0) THEN
            V_DESC := V_DESC || ' NrOrg=' || :NEW.NRORG;
         END IF;
         
         IF NVL(:OLD.DTINCLUSAO, SYSDATE) <> NVL(:NEW.DTINCLUSAO, SYSDATE) THEN
            V_DESC := V_DESC || ' DtInclusao=' || :NEW.DTINCLUSAO;
         END IF;
         
         IF NVL(:OLD.DTULTATU, SYSDATE) <> NVL(:NEW.DTULTATU, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtu=' || :NEW.DTULTATU;
         END IF;
         
         IF NVL(:OLD.NRORGINCLUSAO, 0) <> NVL(:NEW.NRORGINCLUSAO, 0) THEN
            V_DESC := V_DESC || ' NrOrgInclusao=' || :NEW.NRORGINCLUSAO;
         END IF;
         
         IF NVL(:OLD.CDOPERINCLUSAO, ' ') <> NVL(:NEW.CDOPERINCLUSAO, ' ') THEN
            V_DESC := V_DESC || ' CdOperInclusao=' || :NEW.CDOPERINCLUSAO;
         END IF;
         
         IF NVL(:OLD.NRORGULTATU, 0) <> NVL(:NEW.NRORGULTATU, 0) THEN
            V_DESC := V_DESC || ' NrOrgUltAtu=' || :NEW.NRORGULTATU;
         END IF;
         
         IF NVL(:OLD.CDOPERULTATU, ' ') <> NVL(:NEW.CDOPERULTATU, ' ') THEN
            V_DESC := V_DESC || ' CdOperUltAtu=' || :NEW.CDOPERULTATU;
         END IF;
          
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || '|' || :NEW.CDCIA;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('CIAFILI', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_CIAFILI','5.85.xxx'); END;
/

