/* Tabela INSPECAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INSPECAO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSPECAO, utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_INSPECAO' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_INSPECAO
GO
CREATE TRIGGER LOG_CDP_INSPECAO
ON INSPECAO
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDINSPECAO_NEW      VARCHAR(10);
  DECLARE @V_NMINSPECAO_NEW      VARCHAR(200);
  DECLARE @V_CDNVINSPECAO_NEW    VARCHAR(1);
  DECLARE @V_CDARVINSPEC_NEW     VARCHAR(10);
  DECLARE @V_IDSITINSPEC_NEW     VARCHAR(1);
  DECLARE @V_SGUNIDADE_NEW       VARCHAR(10);
  DECLARE @V_IDTPRESPINSP_NEW    VARCHAR(4);
  DECLARE @V_DSLIMIRESP_NEW      VARCHAR(40);
  DECLARE @V_IDATEITEINSP_NEW    VARCHAR(1);
  DECLARE @V_IDORIGINSPEC_NEW    VARCHAR(3);
  DECLARE @V_VRCUSTOINSP_NEW     DOUBLE PRECISION;
  DECLARE @V_CDTIPOAMOS_NEW      VARCHAR(3);
  DECLARE @V_DTULTATUINSP_NEW    DATE;
  DECLARE @V_CDEXTINSPEC_NEW     VARCHAR(20);
  DECLARE @V_DSARQUINSPEC_NEW    VARCHAR(250);
  DECLARE @V_IDCOMPOECUSTO_NEW   VARCHAR(1);
  
  DECLARE @V_CDINSPECAO_OLD      VARCHAR(10);
  DECLARE @V_NMINSPECAO_OLD      VARCHAR(200);
  DECLARE @V_CDNVINSPECAO_OLD    VARCHAR(1);
  DECLARE @V_CDARVINSPEC_OLD     VARCHAR(10);
  DECLARE @V_IDSITINSPEC_OLD     VARCHAR(1);
  DECLARE @V_SGUNIDADE_OLD       VARCHAR(10);
  DECLARE @V_IDTPRESPINSP_OLD    VARCHAR(4);
  DECLARE @V_DSLIMIRESP_OLD      VARCHAR(40);
  DECLARE @V_IDATEITEINSP_OLD    VARCHAR(1);
  DECLARE @V_IDORIGINSPEC_OLD    VARCHAR(3);
  DECLARE @V_VRCUSTOINSP_OLD     DOUBLE PRECISION;
  DECLARE @V_CDTIPOAMOS_OLD      VARCHAR(3);
  DECLARE @V_DTULTATUINSP_OLD    DATE;
  DECLARE @V_CDEXTINSPEC_OLD     VARCHAR(20);
  DECLARE @V_DSARQUINSPEC_OLD    VARCHAR(250);
  DECLARE @V_IDCOMPOECUSTO_OLD   VARCHAR(1);

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';
   
   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL,
         CDINSPECAO,
         NMINSPECAO,
         CDNVINSPECAO,
         CDARVINSPEC,
         IDSITINSPEC,
         SGUNIDADE,
         IDTPRESPINSP,
         DSLIMIRESP,
         IDATEITEINSP,
         IDORIGINSPEC,
         VRCUSTOINSP,
         CDTIPOAMOS,
         DTULTATUINSP,
         CDEXTINSPEC,
         DSARQUINSPEC,
         IDCOMPOECUSTO
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
          INSERTED.CDINSPECAO,
          INSERTED.NMINSPECAO,
          INSERTED.CDNVINSPECAO,
          INSERTED.CDARVINSPEC,
          INSERTED.IDSITINSPEC,
          INSERTED.SGUNIDADE,
          INSERTED.IDTPRESPINSP,
          INSERTED.DSLIMIRESP,
          INSERTED.IDATEITEINSP,
          INSERTED.IDORIGINSPEC,
          INSERTED.VRCUSTOINSP,
          INSERTED.CDTIPOAMOS,
          INSERTED.DTULTATUINSP,
          INSERTED.CDEXTINSPEC,
          INSERTED.DSARQUINSPEC,
          INSERTED.IDCOMPOECUSTO,

          DELETED.CDINSPECAO,
          DELETED.NMINSPECAO,
          DELETED.CDNVINSPECAO,
          DELETED.CDARVINSPEC,
          DELETED.IDSITINSPEC,
          DELETED.SGUNIDADE,
          DELETED.IDTPRESPINSP,
          DELETED.DSLIMIRESP,
          DELETED.IDATEITEINSP,
          DELETED.IDORIGINSPEC,
          DELETED.VRCUSTOINSP,
          DELETED.CDTIPOAMOS,
          DELETED.DTULTATUINSP,
          DELETED.CDEXTINSPEC,
          DELETED.DSARQUINSPEC,
          DELETED.IDCOMPOECUSTO

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDINSPECAO   = DELETED.CDINSPECAO AND
         INSERTED.CDRESPINSPEC = DELETED.CDRESPINSPEC

      UNION ALL

      SELECT
         'I' IDCOMANDO,
          INSERTED.CDINSPECAO,
          INSERTED.NMINSPECAO,
          INSERTED.CDNVINSPECAO,
          INSERTED.CDARVINSPEC,
          INSERTED.IDSITINSPEC,
          INSERTED.SGUNIDADE,
          INSERTED.IDTPRESPINSP,
          INSERTED.DSLIMIRESP,
          INSERTED.IDATEITEINSP,
          INSERTED.IDORIGINSPEC,
          INSERTED.VRCUSTOINSP,
          INSERTED.CDTIPOAMOS,
          INSERTED.DTULTATUINSP,
          INSERTED.CDEXTINSPEC,
          INSERTED.DSARQUINSPEC,
          INSERTED.IDCOMPOECUSTO,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
         
   OPEN C_CURSOR_R;
   FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                    @V_CDINSPECAO_NEW, @V_NMINSPECAO_NEW, @V_CDNVINSPECAO_NEW, @V_CDARVINSPEC_NEW, @V_IDSITINSPEC_NEW,
                                    @V_SGUNIDADE_NEW, @V_IDTPRESPINSP_NEW, @V_DSLIMIRESP_NEW, @V_IDATEITEINSP_NEW, @V_IDORIGINSPEC_NEW,
                                    @V_VRCUSTOINSP_NEW, @V_CDTIPOAMOS_NEW, @V_DTULTATUINSP_NEW, @V_CDEXTINSPEC_NEW, @V_DSARQUINSPEC_NEW,
                                    @V_IDCOMPOECUSTO_NEW,
                                    
                                    @V_CDINSPECAO_OLD, @V_NMINSPECAO_OLD, @V_CDNVINSPECAO_OLD, @V_CDARVINSPEC_OLD, @V_IDSITINSPEC_OLD,
                                    @V_SGUNIDADE_OLD, @V_IDTPRESPINSP_OLD, @V_DSLIMIRESP_OLD, @V_IDATEITEINSP_OLD, @V_IDORIGINSPEC_OLD,
                                    @V_VRCUSTOINSP_OLD, @V_CDTIPOAMOS_OLD, @V_DTULTATUINSP_OLD, @V_CDEXTINSPEC_OLD, @V_DSARQUINSPEC_OLD,
                                    @V_IDCOMPOECUSTO_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN


      IF @V_TIPO = 'D' BEGIN   
         IF @V_CDINSPECAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo = ' + ISNULL(@V_CDINSPECAO_OLD,'') + ' ';
         END;
         IF @V_NMINSPECAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo = ' + ISNULL(@V_NMINSPECAO_OLD,'') + ' ';
         END;
         IF @V_CDNVINSPECAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nvel = ' + ISNULL(@V_CDNVINSPECAO_OLD,'') + ' ';
         END;
         IF @V_CDARVINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo rvore = ' + ISNULL(@V_CDARVINSPEC_OLD,'') + ' ';
         END;
         IF @V_IDSITINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Situao = ' + ISNULL(@V_IDSITINSPEC_OLD,'') + ' ';
         END;
         IF @V_SGUNIDADE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Unidade = ' + ISNULL(@V_SGUNIDADE_OLD,'') + ' ';
         END;
         IF @V_IDTPRESPINSP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Resposta = ' + ISNULL(@V_IDTPRESPINSP_OLD,'') + ' ';
         END;
         IF @V_DSLIMIRESP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Limite = ' + ISNULL(@V_DSLIMIRESP_OLD,'') + ' ';
         END;
         IF @V_IDATEITEINSP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Atendimento = ' + ISNULL(@V_IDATEITEINSP_OLD,'') + ' ';
         END;
         IF @V_IDORIGINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Origem = ' + ISNULL(@V_IDORIGINSPEC_OLD,'') + ' ';
         END;
         IF @V_VRCUSTOINSP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Custo = ' + ISNULL(CONVERT(VARCHAR,@V_VRCUSTOINSP_OLD),'') + ' ';            
         END;
         IF @V_CDTIPOAMOS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Amostra = ' + ISNULL(@V_CDTIPOAMOS_OLD,'') + ' ';
         END;
         IF @V_DTULTATUINSP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + ISNULL(@V_DTULTATUINSP_OLD,'') + ' ';
         END;
         IF @V_CDEXTINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo Externo = ' + ISNULL(@V_CDEXTINSPEC_OLD,'') + ' ';
         END;
         IF @V_DSARQUINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Arquivo = ' + ISNULL(@V_DSARQUINSPEC_OLD,'') + ' ';
         END;
         IF @V_CDARVINSPECANTE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo rvore Anterior = ' + ISNULL(@V_CDARVINSPECANTE_OLD,'') + ' ';
         END;
         IF @V_IDCOMPOECUSTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Compe Custo = ' + ISNULL(@V_IDCOMPOECUSTO_OLD,'') + ' ';
         END;
         
         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_CDINSPECAO_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
           IF (@V_CDINSPECAO_OLD   <> @V_CDINSPECAO_OLD  ) OR
              (@V_CDRESPINSPEC_OLD <> @V_CDRESPINSPEC_OLD) OR
              (@V_NMRESPINSPEC_OLD <> @V_NMRESPINSPEC_OLD) OR
              (@V_IDFAIXRESINS_OLD <> @V_IDFAIXRESINS_OLD) OR
              (@V_VRINIFAIXRES_OLD <> @V_VRINIFAIXRES_OLD) OR
              (@V_VRFINFAIXRES_OLD <> @V_VRFINFAIXRES_OLD) OR
              (@V_VRPONTRESINS_OLD <> @V_VRPONTRESINS_OLD) OR
              (@V_CDPRODUTO_OLD    <> @V_CDPRODUTO_OLD   ) OR
              (@V_SGUNIDADE_OLD    <> @V_SGUNIDADE_OLD   ) OR
              (@V_IDRESPPROC_OLD   <> @V_IDRESPPROC_OLD  ) OR
              (@V_IDSTATUSRESP_OLD <> @V_IDSTATUSRESP_OLD) OR
              (@V_DTINIFAIXRES_OLD <> @V_DTINIFAIXRES_OLD) OR
              (@V_DTFINFAIXRES_OLD <> @V_DTFINFAIXRES_OLD) OR
              (@V_DTULTATURINS_OLD <> @V_DTULTATURINS_OLD) BEGIN

               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_CDINSPECAO_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_CDINSPECAO_NEW;
         END;
         
         IF ISNULL(@V_CDINSPECAO_NEW, '!') <> ISNULL(@V_CDINSPECAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo = ' + @V_CDINSPECAO_NEW;
         END;
         IF ISNULL(@V_NMINSPECAO_NEW, '!') <> ISNULL(@V_NMINSPECAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo = ' + @V_NMINSPECAO_NEW;
         END;
         IF ISNULL(@V_CDNVINSPECAO_NEW, '!') <> ISNULL(@V_CDNVINSPECAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Nvel = ' + @V_CDNVINSPECAO_NEW;
         END;
         IF ISNULL(@V_CDARVINSPEC_NEW, '!') <> ISNULL(@V_CDARVINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo rvore = ' + @V_CDARVINSPEC_NEW;
         END;
         IF ISNULL(@V_IDSITINSPEC_NEW, '!') <> ISNULL(@V_IDSITINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Situao = ' + @V_IDSITINSPEC_NEW;
         END;
         IF ISNULL(@V_SGUNIDADE_NEW, '!') <> ISNULL(@V_SGUNIDADE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Unidade = ' + @V_SGUNIDADE_NEW;
         END;
         IF ISNULL(@V_IDTPRESPINSP_NEW, '!') <> ISNULL(@V_IDTPRESPINSP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Resposta = ' + @V_IDTPRESPINSP_NEW;
         END;
         IF ISNULL(@V_DSLIMIRESP_NEW, '!') <> ISNULL(@V_DSLIMIRESP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Limite = ' + @V_DSLIMIRESP_NEW;
         END;
         IF ISNULL(@V_IDATEITEINSP_NEW, '!') <> ISNULL(@V_IDATEITEINSP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Atendimento = ' + @V_IDATEITEINSP_NEW;
         END;
         IF ISNULL(@V_IDORIGINSPEC_NEW, '!') <> ISNULL(@V_IDORIGINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Origem = ' + @V_IDORIGINSPEC_NEW;
         END;
         IF ISNULL(@V_VRCUSTOINSP_NEW, '!') <> ISNULL(@V_VRCUSTOINSP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Custo = ' + CONVERT(VARCHAR,@V_VRCUSTOINSP_NEW);
         END;
         IF ISNULL(@V_CDTIPOAMOS_NEW, '!') <> ISNULL(@V_CDTIPOAMOS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Amostra = ' + @V_CDTIPOAMOS_NEW;
         END;
         IF ISNULL(@V_DTULTATUINSP_NEW, '!') <> ISNULL(@V_DTULTATUINSP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + @V_DTULTATUINSP_NEW;
         END;
         IF ISNULL(@V_CDEXTINSPEC_NEW, '!') <> ISNULL(@V_CDEXTINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo Externo = ' + @V_CDEXTINSPEC_NEW;
         END;
         IF ISNULL(@V_DSARQUINSPEC_NEW, '!') <> ISNULL(@V_DSARQUINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Arquivo = ' + @V_DSARQUINSPEC_NEW;
         END;
         IF ISNULL(@V_CDARVINSPECANTE_NEW, '!') <> ISNULL(@V_CDARVINSPECANTE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo rvore Anterior = ' + @V_CDARVINSPECANTE_NEW;
         END;
         IF ISNULL(@V_IDCOMPOECUSTO_NEW, '!') <> ISNULL(@V_IDCOMPOECUSTO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Compe Custo = ' + @V_IDCOMPOECUSTO_NEW;
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN

            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                CDFILLOGOPER,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('INSPECAO',
                @V_DTOPER,
                @V_USUARIO,
                @V_TPMOVI,
                @V_ITPESQ,
                SUBSTRING(@V_DESC,1,300),
                @V_CDFILLOGOPER,
                @V_DSSERVERRDM,
                @V_DSREMOTEADDR,
                @V_DSREMOTEHOST,
                @V_DSSERVMETHOD,
                @V_DSREMOTEOPER);

         END;
      END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                      @V_CDINSPECAO_NEW, @V_NMINSPECAO_NEW, @V_CDNVINSPECAO_NEW, @V_CDARVINSPEC_NEW, @V_IDSITINSPEC_NEW,
                                      @V_SGUNIDADE_NEW, @V_IDTPRESPINSP_NEW, @V_DSLIMIRESP_NEW, @V_IDATEITEINSP_NEW, @V_IDORIGINSPEC_NEW,
                                      @V_VRCUSTOINSP_NEW, @V_CDTIPOAMOS_NEW, @V_DTULTATUINSP_NEW, @V_CDEXTINSPEC_NEW, @V_DSARQUINSPEC_NEW,
                                      @V_IDCOMPOECUSTO_NEW,
                                      
                                      @V_CDINSPECAO_OLD, @V_NMINSPECAO_OLD, @V_CDNVINSPECAO_OLD, @V_CDARVINSPEC_OLD, @V_IDSITINSPEC_OLD,
                                      @V_SGUNIDADE_OLD, @V_IDTPRESPINSP_OLD, @V_DSLIMIRESP_OLD, @V_IDATEITEINSP_OLD, @V_IDORIGINSPEC_OLD,
                                      @V_VRCUSTOINSP_OLD, @V_CDTIPOAMOS_OLD, @V_DTULTATUINSP_OLD, @V_CDEXTINSPEC_OLD, @V_DSARQUINSPEC_OLD,
                                      @V_IDCOMPOECUSTO_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_INSPECAO','5.85.XXX';
GO

         